#define LABELSIZE 1024
#define LINEBUFSIZE 1024
#define MAXLABLES 1024
#define TABWIDTH 5
#define COMMENTPLACEMENT 50

#define FIRST 0
#define SECOND 1

#define MAX_INCLUDE_DEPTH 10

#define TRUE 1
#define FALSE 0

#define ADD_calc 1
#define SUB_calc 2
#define AND_calc 3
#define OR_calc  4
#define XOR_calc 5
#define SLL_calc 6
#define SLR_calc 7

#define MUL_calc 8
#define DIV_calc 9
#define POW_calc 10


/********************************/

#define NoOfGRegs 2
#define NoOfRRegs 8

#define REGBS 10
#define REGSR 11
#define REGPC 12
#define REGSP 13
#define REGFIFO 14
#define REGIMM 15

#define OP_add   "0000"
#define OP_sub   "0001"
#define OP_and   "0010"
#define OP_or    "0011"
#define OP_xor   "0100"
#define OP_sll   "0101"
#define OP_slr   "0110"
#define OP_load  "0111"
#define OP_store "1000"

#define OP_slli       "1001"
#define OP_slri       "1010"

#define OP_addi       "1011"
#define OP_loadi      "1100"
#define OP_storei     "1101"
#define OP_set        "1110"

#define OP_jump       "1111000"
#define OP_jumplz     "1111001"
#define OP_jumpnz     "1111010"
#define OP_call       "1111011"

#define OP_popfifo    "11111010"
#define OP_popfifoi   "11111011"
#define OP_readfifo   "11111000"
#define OP_readfifoi  "11111001"

#define OP_mask1      "1111110000"
#define OP_mask2      "1111110001"
/* #define OP_shiftfifo  "111111001000" */
#define OP_push       "111111001000"
#define OP_pop        "111111001100"
#define OP_inc        "111111010000"
#define OP_dec        "111111010100"
/* #define OP_shiftfifoi "111111011100" */
#define OP_resetfifo  "111111011000"
#define OP_nop        "111111011100"
#define OP_rti        "111111100000"
#define OP_lcall      "111111100100"
